<?php
/***************************************************************************
 *   Copyright (C) 2005-2006 Artur Wiebe                                   *
 *   wibix@gmx.de                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
require_once("../../maincore.php");
require_once(BASEDIR."subheader.php");
require_once(BASEDIR."side_left.php");

if(!iSUPERADMIN) {
	fallback("about.php");
}

require_once("include/common.php");

?>
<script type='text/javascript'>
function awc_ok_del() {
	return confirm("<?php echo $locale['AWC759']; ?>");
}
</script>
<?php



if(isset($_GET['id']) && isNum($_GET['id'])) {
	$id = $_GET['id'];
} else {
	unset($id);
}


function get_all_states($id, $state) {
	$all_states = array(
		AW_RUNNING,
		AW_WHITE,
		AW_WHITE_G,
		AW_BLACK,
		AW_BLACK_G,
		AW_REMIS,
		AW_PAUSED,
		CHESS_REQUEST,
	);
	$ret_array = array();
	$href = FUSION_SELF."?id=$id&state";
	foreach($all_states as $s) {
		$ret_array[] = ($s!=$state ? "<a href='$href=$s'>".$s."</a>"
				: "<b>$s</b>");
	}
//	return implode(" - ", $ret_array);
	return implode("", $ret_array);
}


/*
 * ACTION
 */
unset($query);
if(isset($_GET['public']) && isset($id)) {
	$query = "UPDATE ".DB_PREFIX."aw_chess SET public='".$_GET['public']."'"
		." WHERE id='$id'";

} elseif(isset($_GET['state']) && isset($id)) {
	$state = $_GET['state'];
	$query = "UPDATE ".DB_PREFIX."aw_chess SET state='$state'"
		." WHERE id='$id'";

} elseif(isset($_GET['delete'])) {
	$query = "DELETE FROM ".DB_PREFIX."aw_chess WHERE id='$id'";
}


if(isset($query)) {
	if(dbquery($query)) {
		redirect(FUSION_SELF);
	} else {
		awc_msg(false, $query);
	}
}


/*
 * GUI
 */
opentable($locale['AWC750']);
awc_show_menu();

if(isset($_GET['state'])) {
	$where = "awc.state='".stripinput($_GET['state'])."'";
} else {
	$where = "awc.state!='*'";
}
$rowstart = 0;
if(isset($_GET['rowstart']) && isNum($_GET['rowstart'])) {
	$rowstart = $_GET['rowstart'];
}
echo "<table border='0' align='center'>
<tr>
	<td><a href='".FUSION_SELF."'>".$locale['AWC010']."</a></td>
	<td>|</td>
	<td><a href='".FUSION_SELF."?state=?'>".$locale['AWC755']."</a></td>
	<td>|</td>
	<td><a href='".FUSION_SELF."?state=r'>".$locale['AWC756']."</a></td>
</tr>
</table>\n";


// show all games.
$query_id = dbquery("SELECT awc.id, awc.owner_id, awc.black_id, awc.white_id,"
	." awc.state, awc.ctime, awc.mtime, awc.public, awc.request_id,"
	." awc.white_next, awc.request_msg,"
	." fu_w.user_name AS white_name, fu_b.user_name AS black_name"
	." FROM ".DB_PREFIX."aw_chess AS awc"
	." LEFT JOIN ".DB_PREFIX."users AS fu_w ON fu_w.user_id=awc.white_id"
	." LEFT JOIN ".DB_PREFIX."users AS fu_b ON fu_b.user_id=awc.black_id"
	." WHERE $where ORDER BY state, mtime DESC"
	." LIMIT $rowstart, ".AW_PER_PAGE);

echo "<table width='100%' cellspacing='1' class='tbl-border'>
<tr class='tbl'>
	<td class='tbl2' width='1%'></td>
	<td class='tbl2'><b>".$locale['AWC757']."</b></td>
<td class='tbl2' width='1%'><b>".$locale['AWC006']."</b>*</td>
	<td class='tbl2' width='1%'><b>".$locale['AWC007']."</b>*</td>
	<td class='tbl2'><b>".$locale['AWC016']."</b></td>
	<td class='tbl2'><b>".$locale['AWC017']."</b></td>
	<td class='tbl2' align='center'><img src='icons/locked.gif'"
		." alt='".$locale['AWC102']."'"
		." title='".$locale['AWC102']."'></td>
	<td class='tbl2' align='center'><b>".$locale['AWC019']."</b>**</td>
	<td class='tbl2'></td>
</tr>\n";
$count = 1;
$last_state = "";
while($row = dbarray($query_id)) {
	$tbl = "tbl".(1 + (++$count%2));

	$id = $row['id'];
	$state = $row['state'];

	if($state != $last_state) {
		echo "<tr><td colspan='9' class='forum-caption'>"
			.$locale['AWC997'][$state]."</td></tr>\n";
		$last_state = $state;
	}

	$white_name = $row['white_name'];
	$black_name = $row['black_name'];

	// owner?
	switch($row['owner_id']) {
	case $row['white_id']:	$owner = $white_name;		break;
	case $row['black_id']:	$owner = $black_name;		break;
	default:		$owner = $locale['AWC021'];	break;
	}
	// request sender
	if($state==CHESS_REQUEST) {
		switch($row['request_id']) {
		case $row['white_id']:	$req_id = $white_name;		break;
		case $row['black_id']:	$req_id = $black_name;		break;
		default:		$req_id = $locale['AWC021'];	break;
		}
	}

	// show
	if($state==AW_RUNNING || $state==CHESS_REQUEST) {
		if($row['white_next']=="Y") {
			$white_name = "<u>$white_name</u>";
		} else {
			$black_name = "<u>$black_name</u>";
		}
	}
	echo "<tr>
	<td class='$tbl'><a href='viewgame.php?id=$id'>"
		."<img src='icons/view.gif' alt='$id' border='0'></a></td>
	<td class='$tbl'>$owner</td>
	<td class='$tbl' align='center'>$white_name</td>
	<td class='$tbl' align='center'>$black_name</td>
	<td class='$tbl'>".showdate("shortdate", $row['ctime'])."</td>
	<td class='$tbl'>".showdate("shortdate", $row['mtime'])."</td>
	<td align='center' class='$tbl'><a href='".FUSION_SELF."?id=$id"
		."&public=".($row['public']=="N" ? "Y" : "N") . "'>"
		.$row['public']."</a></td>
	<td class='$tbl' align='center'>".get_all_states($id, $state)."</td>
	<td class='$tbl'>"
		."<a href='".FUSION_SELF."?id=$id&delete=yes'"
		." onClick='return awc_ok_del();'><img src='icons/delete.gif'"
		." alt='".$locale['AWC758']."' title='".$locale['AWC758']."'"
		." border='0'></a></td>"
	."</tr>";
	if($state==CHESS_REQUEST) {
		echo "<tr><td class='$tbl'></td>"
			."<td colspan='8' class='$tbl'><b>$req_id:</b>"
			." <span class='small2'>".$row['request_msg']
			."</small></td></tr>";
	}
}
echo "</table>\n";

$count = dbcount("(*)", "aw_chess AS awc", "$where");
if($count >= AW_PER_PAGE) {
	tablebreak();
	echo "<div align='center'>"
		.makePageNav($rowstart, AW_PER_PAGE, $count, $count,
			FUSION_SELF
				.(isset($_GET['state'])
					? "?state=".$_GET['state']."&"
					: "?"))
		."</div>\n";
}

closetable();
tablebreak();


opentable($locale['AWC751']);
echo "<b>* ".$locale['AWC753']."</b>
<ul>
	<li>".$locale['AWC754']."</li>
</ul>\n";

echo "<b>** ".$locale['AWC019']."</b>
<ul>";
foreach($locale['AWC997'] as $state => $line) {
	echo "<li><b>$state</b> - $line</li>\n";
}
echo "</ul>\n";
closetable();


require_once(BASEDIR."side_right.php");
require_once(BASEDIR."footer.php");
?>
