<?php
/***************************************************************************
 *   Copyright (C) 2005-2006 Artur Wiebe                                   *
 *   wibix@gmx.de                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
define("AW_IMAGES",		INFUSIONS."aw_chess/images/");
define("CHESS_IMG_GAME",	AW_IMAGES."game.gif");
define("CHESS_IMG_NEW",		AW_IMAGES."gamenew.gif");
define("CHESS_IMG_MY",		AW_IMAGES."gamemy.gif");

define("AWC_EMOVE",	1);
define("AWC_ECAPTURE",	2);
define("AWC_EUPDATE",	3);
define("AWC_EKINGKILL",	4);
//5
define("AWC_ECOMMENT",	6);
define("AWC_EREQUEST",	7);
define("AWC_EACCESS",	8);
define("AWC_ENEWGAME",	9);


// read settings
$awc_settings = dbarray(dbquery("SELECT * FROM ".DB_PREFIX."aw_chess_settings"));
if(!$awc_settings) {
	$awc_settings['enabled']	= "1";
	$awc_settings['max_games']	= "5";
	$awc_settings['admin_id']	= "0";
	$awc_settings['reason']		= "";
	$awc_settings['version']	= "0.0.0";
}
define("AW_MAX_GAMES",	$awc_settings['max_games']);
define("AWC_ONLINE",	$awc_settings['enabled']);
define("AW_ADMIN_PM",	$awc_settings['admin_pm']);
define("AW_PER_PAGE",	$awc_settings['per_page']);


if(file_exists(INFUSIONS."aw_chess/locale/".$settings['locale'].".php")) {
        include INFUSIONS."aw_chess/locale/".$settings['locale'].".php";
} else {
        include INFUSIONS."aw_chess/locale/German.php";
}

define("AW_SEP",		",");
define("AW_UNDO",		"_");
define("AWC_BOARD",		"tsldklstbbbbbbbb--------------------------------BBBBBBBBTSLDKLST");

define("AW_RUNNING",	"r");
define("AW_WHITE",	"W");	// white won
define("AW_WHITE_G",	"w");	// white won - black gave up
define("AW_BLACK",	"B");	// black won
define("AW_BLACK_G",	"b");	// black won - white gave up
define("AW_REMIS",	"M");
define("AW_PAUSED",	"p");
define("CHESS_REQUEST",	"?");


$awc_board_size = 33;

function show_game_list($user_id, $game_id, $running) {
	global $locale, $lastvisited;

	$rowstart = "0";
	if(isset($_GET['rowstart']) && isNum($_GET['rowstart'])) {
		$rowstart = $_GET['rowstart'];
	}

	$only_mine = false;
	$where = "";
	if(iMEMBER) {
		if(isset($_GET['only']) && $_GET['only']=="mine") {
			$only_mine = true;
			$where .= "(awc.white_id='$user_id' OR awc.black_id='$user_id')";
		} else {
			$where .= "(awc.white_id='$user_id' OR awc.black_id='$user_id'"
				. " OR awc.public='Y')";
		}
	} else {
		$where .= " awc.public='Y' ";
	}
	if($running) {
		$where .= " AND (awc.state='".AW_RUNNING."'"
			." OR awc.state='".CHESS_REQUEST."')";
	} else {
		$where .= " AND (awc.state!='".AW_RUNNING."'"
			." AND awc.state!='".CHESS_REQUEST."')";
	}

	$query = "SELECT awc.id, awc.owner_id, awc.white_next, awc.white_id,"
		." awc.black_id, awc.ctime, awc.mtime, awc.state,"
		." fu_w.user_name AS white_name, fu_b.user_name AS black_name"
		." FROM ".DB_PREFIX."aw_chess AS awc"
		." LEFT JOIN ".DB_PREFIX."users AS fu_w"
			." ON fu_w.user_id=awc.white_id"
		." LEFT JOIN ".DB_PREFIX."users AS fu_b"
			." ON fu_b.user_id=awc.black_id"
		." WHERE $where ORDER by awc.mtime DESC"
		." LIMIT $rowstart, ".AW_PER_PAGE;
	$query_id = dbquery($query);
	if(!$query_id || dbrows($query_id)==0) {
		// FIXME some stuff
		echo "<p>".$locale['AWC803'];
		return 0;
	}

	$from = $locale['AWC804'];
	if(iMEMBER) {
		echo "<div align='right'><b>".$locale['AWC805'].":</b> "
			."<a href='".FUSION_SELF."'>".$locale['AWC801']."</a>";
		echo " | <a href='".FUSION_SELF."?only=mine'>"
			.$locale['AWC802']."</a>";
		echo "</div>\n";
	}
	echo "<table width='100%' class='tbl-border' cellspacing='1'>\n"
		."<tr><td class='tbl2' width='1%'></td>"
		."<td class='tbl2' width='24%'></td>"
		."<td class='tbl2' width='25%'><b>".$locale['AWC016']
			."</b></td>"
		."<td class='tbl2' width='25%'><b>".$locale['AWC017']
			."</b></td>";
	if(!$running) {
		echo "<td class='tbl2' width='25%'><b>".$locale['AWC019']
			."</b></td>";
	}
	echo "\n</tr>";
	while($game = dbarray($query_id)) {
		$white_name = $game['white_name'];
		$black_name = $game['black_name'];

		// show game.
		$id = $game['id'];
		$white_next = ($game['white_next']=="Y");

		$img = CHESS_IMG_GAME;
		if($running) {
			if(($white_next && $user_id==$game['white_id']) ||
				(!$white_next && $user_id==$game['black_id'])) {
				$img = CHESS_IMG_MY;
			} elseif($game['mtime'] >= $lastvisited) {
				$img = CHESS_IMG_NEW;
			}
		} else {
			if($game['state']==AW_WHITE
				|| $game['state']==AW_WHITE_G) {
				$white_name = "<b>$white_name</b>";
			}
			if($game['state']==AW_BLACK
				|| $game['state']==AW_BLACK_G) {
				$black_name = "<b>$black_name</b>";
			}
			$status = $locale['AWC997'][$game['state']];
		}

		if($white_next) {
			$last = "<a href='".BASEDIR."profile.php?lookup="
				.$game['black_id']."'>$black_name</a>";
		} else {
			$last = "<a href='".BASEDIR."profile.php?lookup="
				.$game['white_id']."'>$white_name</a>";
		}

		$owner = ($game['owner_id']==$game['white_id']
			? $white_name : $black_name);
		$owner = "<a href='".BASEDIR."profile.php?lookup="
			.$game['owner_id']."'>$owner</a>";

		echo "<tr><td class='tbl2'><img src='$img' alt=''></td>
	<td class='tbl1' style='white-space:nowrap;'><a href='".INFUSIONS."aw_chess/viewgame.php?id=$id'>"
		."$white_name - $black_name</a>
	</td>
	<td class='tbl2' style='white-space:nowrap;'>".showdate("shortdate", $game['ctime'])."<br>"
		."$from $owner</td>
	<td class='tbl1' style='white-space:nowrap;'>".showdate("shortdate", $game['mtime'])."<br>"
		."$from $last</td>\n";
	if(!$running) {
		echo "<td class='tbl2'>$status</td>\n";
	}
	echo "</tr>\n";
	}
	echo "</table>\n";

	$count = dbcount("(*)", "aw_chess AS awc", "$where");
	if($count > AW_PER_PAGE) {
		tablebreak();
		echo "<div align='center'>"
			.makePageNav($rowstart, AW_PER_PAGE,
			$count, $count, FUSION_SELF
				.($only_mine ? "?only=mine&" : "?"))."</div>";
	}
}


function awc_msg($ok, $msg="") {
	global $locale;

	opentable($locale['AWC800']);
	echo "<div align='center'><img src='icons/".($ok ? "ok" : "no").".gif'"
		." alt=''><p><b>$msg</b></div>\n";
	closetable();
	tablebreak();
}


/*
 * MENU
 */
function awc_show_menu() {
	global $locale;

	$items = array();

	if(AWC_ONLINE || iSUPERADMIN) {
		$items[] = "<a href='index.php'>".$locale['AWC011']."</a>";
		$items[] = "<a href='archive.php'>".$locale['AWC012']."</a>";
		if(iMEMBER) {
			$items[] = "<a href='newgame.php'>".$locale['AWC013']."</a>";
			$items[] = "<a href='stats.php'>".$locale['AWC014']."</a>";
		}
	}
	$items[] = "<a href='about.php'>".$locale['AWC015']."</a>";

	echo "<table border='0' cellspacing='0' cellpadding='0' width='100%'>
<tr>
	<td>".implode(" | ", $items)."</td>\n";

	if(iSUPERADMIN) {
		// count requests
		$count = dbcount("(*)", "aw_chess",
			"(state='".CHESS_REQUEST."')");

		echo "<td align='right'>"
			."<a href='gameadmin.php'>".$locale['AWC750']
			.($count ? " ($count)"  : "")."</a>"
			." | <a href='settings.php'>".$locale['AWC700']."</a>"
			."</td>\n";
	}

	echo "
</tr>
</table><hr>";
}


function awc_send_pm($from_id, $to_id, $subject, $body)
{
	global $settings, $locale, $userdata;

	if($from_id==$to_id) {
		return true;
	}

	$ok = dbquery("INSERT INTO ".DB_PREFIX."messages"
		."(message_to, message_from, message_subject,"
		." message_message,"
		." message_smileys, message_read, message_datestamp)"
		." VALUES "
		."('$to_id', '$from_id', '$subject',"
		." '$body', 'y', '0', '".time()."')");

	if(dbcount("(*)", "messages_options",
		"user_id='$to_id' AND pm_email_notify='1'")) {

		require_once(INCLUDES."sendmail_include.php");
		$query_id = dbquery("SELECT user_name, user_email"
			." FROM ".DB_PREFIX."users"
			." WHERE user_id='$to_id'");
		if(!dbrows($query_id)) {
			return $ok;
		}
		$data = dbarray($query_id);
		$mail_addr = $data['user_email'];
		$to_name = $data['user_name'];
		$type = "html";

		$body = $userdata['user_name'].",<br><br>"
			.nl2br(parseubb($body));

		sendemail($to_name, $mail_addr,
			$settings['siteusername'], $settings['siteemail'],
			$subject, $body, $type);
	}

	return $ok;
}


if(!AWC_ONLINE && !iSUPERADMIN && FUSION_SELF!="about.php") {
	fallback("about.php");
}

?>
