<?php
/***************************************************************************
 *   Copyright (C) 2005-2006 Artur Wiebe                                   *
 *   wibix@gmx.de                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
require_once("../../maincore.php");
require_once(BASEDIR."subheader.php");
require_once(BASEDIR."side_left.php");

if(!iSUPERADMIN) {
	fallback("about.php");
}

require_once("include/common.php");


/*
 * ACTION
 */
if(isset($_POST['save'])) {
	$enabled = (isset($_POST['enabled']) ? "1" : "0");
	$max_games = stripinput($_POST['max_games']);
	$admin_pm = stripinput($_POST['admin_pm']);
	$per_page = stripinput($_POST['per_page']);
	$reason = stripinput($_POST['reason']);
	$player_grp = stripinput($_POST['player_grp']);
	if(!$player_grp) {
		$player_grp = "101";
	}
	$ok = dbquery("UPDATE ".DB_PREFIX."aw_chess_settings"
		." SET enabled='$enabled',"
		." max_games='$max_games',"
		." admin_pm='$admin_pm',"
		." per_page='$per_page',"
		." reason='$reason',"
		." player_group='$player_grp'");
	fallback(FUSION_SELF);
}


/*
 * GUI - settings
 */
require_once("db_update.php");

opentable($locale['AWC700']);
awc_show_menu();

// admins
$pm_ops = "<option value='0'>".$locale['AWC707']."</option>";
$query_id = dbquery("SELECT user_id, user_name FROM ".DB_PREFIX."users"
	." WHERE user_level='103'");
if($query_id) {
	while($row = dbarray($query_id)) {
		$id = $row['user_id'];
		$pm_ops .= "<option value='$id'"
			.($id==AW_ADMIN_PM ? " selected" : "").">"
			.$row['user_name']."</option>";
	}
}

$player_sel = "";
$fusion_groups = getusergroups();
foreach($fusion_groups as $data) {
	$gid = $data[0];
	if(!$gid) {
		continue;
	}
	$player_sel .= "<option value='$gid'"
		.($gid==$awc_settings['player_group'] ? " selected" : "")
		.">".$data[1]."</option>\n";
}

$boards_sel = "";
$fid = opendir(AW_IMAGES);
while(($file = readdir($fid)) !== false) {
	if(substr($file, 0, 5) == "board") {
		$boards_sel .= "<option>".substr($file, 0, -4)."</option>\n";
	}
}
closedir($fid);


// show global settings.
echo "<p><form method='post' action='".FUSION_SELF."'>
<table border='0'>
<tr>
	<td>".$locale['AWC702'].":</td>
	<td><input type='textbox' name='per_page' class='textbox' size='3'"
		." value='".AW_PER_PAGE."'></td>
</tr>
<tr>
	<td>".$locale['AWC703'].":</td>
	<td><input type='textbox' name='max_games' class='textbox' size='3'"
		." value='".AW_MAX_GAMES."'></td>
</tr>
<tr>
	<td>".$locale['AWC704'].":</td>
	<td><select name='admin_pm' class='textbox'>$pm_ops</select></td>
</tr>
<tr>
	<td>".$locale['AWC701'].":</td>
	<td><select name='player_grp' class='textbox'>$player_sel</select></td>
</tr>
<tr>
	<td>".$locale['AWC706'].":</td>
	<td><select name='board_theme' class='textbox'>$boards_sel</select></td>
</tr>
<tr>
	<td valign='top'>".$locale['AWC002'].":</td>
<td><input type='checkbox' name='enabled' class='textbox'"
	." value='".(AWC_ONLINE ? "Y" : "N")."'"
	.(AWC_ONLINE ? " checked" : "")."> ".$locale['AWC705']."<br>
	<textarea class='textbox' name='reason' cols='60' rows='6'>"
		.$awc_settings['reason']."</textarea>
</tr>
<tr>
	<td></td>
	<td><input type='submit' class='button' name='save'"
		." value='".$locale['AWC003']."'></td>
</table></form>";
closetable();


require_once(BASEDIR."side_right.php");
require_once(BASEDIR."footer.php");
?>
